SDL_mouse.c File Reference
`#include "../SDL_internal.h"`
`#include "SDL_assert.h"`
`#include "SDL_hints.h"`
`#include "SDL_timer.h"`
`#include "SDL_events.h"`
`#include "SDL_events_c.h"`
`#include "../video/SDL_sysvideo.h"`
`#include "../core/windows/SDL_windows.h"`
Include dependency graph for SDL_mouse.c:

Go to the source code of this file.

## Functions

static int | SDL_PrivateSendMouseMotion (SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
static void | SDL_MouseDoubleClickTimeChanged (void *userdata, const char *name, const char *oldValue, const char *hint)
static void | SDL_MouseDoubleClickRadiusChanged (void *userdata, const char *name, const char *oldValue, const char *hint)
static void | SDL_MouseNormalSpeedScaleChanged (void *userdata, const char *name, const char *oldValue, const char *hint)
static void | SDL_MouseRelativeSpeedScaleChanged (void *userdata, const char *name, const char *oldValue, const char *hint)
static void | SDL_TouchMouseEventsChanged (void *userdata, const char *name, const char *oldValue, const char *hint)
static void | SDL_MouseTouchEventsChanged (void *userdata, const char *name, const char *oldValue, const char *hint)
int | SDL_MouseInit (void)
void | SDL_SetDefaultCursor (SDL_Cursor *cursor)
SDL_Mouse * | SDL_GetMouse (void)
SDL_Window * | SDL_GetMouseFocus (void)
| Get the window which currently has mouse focus. More...
void | SDL_SetMouseFocus (SDL_Window *window)
static SDL_bool | SDL_UpdateMouseFocus (SDL_Window *window, int x, int y, Uint32 buttonstate, SDL_bool send_mouse_motion)
int | SDL_SendMouseMotion (SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
static int | GetScaledMouseDelta (float scale, int value, float *accum)
static SDL_MouseClickState * | GetMouseClickState (SDL_Mouse *mouse, Uint8 button)
static int | SDL_PrivateSendMouseButton (SDL_Window *window, SDL_MouseID mouseID, Uint8 state, Uint8 button, int clicks)
int | SDL_SendMouseButtonClicks (SDL_Window *window, SDL_MouseID mouseID, Uint8 state, Uint8 button, int clicks)
int | SDL_SendMouseButton (SDL_Window *window, SDL_MouseID mouseID, Uint8 state, Uint8 button)
int | SDL_SendMouseWheel (SDL_Window *window, SDL_MouseID mouseID, float x, float y, SDL_MouseWheelDirection direction)
void | SDL_MouseQuit (void)
Uint32 | SDL_GetMouseState (int *x, int *y)
| Retrieve the current state of the mouse. More...
Uint32 | SDL_GetRelativeMouseState (int *x, int *y)
| Retrieve the relative state of the mouse. More...
Uint32 | SDL_GetGlobalMouseState (int *x, int *y)
| Get the current state of the mouse, in relation to the desktop. More...
void | SDL_WarpMouseInWindow (SDL_Window *window, int x, int y)
| Moves the mouse to the given position within the window. More...
int | SDL_WarpMouseGlobal (int x, int y)
| Moves the mouse to the given position in global screen space. More...
static SDL_bool | ShouldUseRelativeModeWarp (SDL_Mouse *mouse)
int | SDL_SetRelativeMouseMode (SDL_bool enabled)
| Set relative mouse mode. More...
SDL_bool | SDL_GetRelativeMouseMode ()
| Query whether relative mouse mode is enabled. More...
int | SDL_CaptureMouse (SDL_bool enabled)
| Capture the mouse, to track input outside an SDL window. More...
SDL_Cursor * | SDL_CreateCursor (const Uint8 *data, const Uint8 *mask, int w, int h, int hot_x, int hot_y)
| Create a cursor, using the specified bitmap data and mask (in MSB format). More...
SDL_Cursor * | SDL_CreateColorCursor (SDL_Surface *surface, int hot_x, int hot_y)
| Create a color cursor. More...
SDL_Cursor * | SDL_CreateSystemCursor (SDL_SystemCursor id)
| Create a system cursor. More...
void | SDL_SetCursor (SDL_Cursor *cursor)
| Set the active cursor. More...
SDL_Cursor * | SDL_GetCursor (void)
| Return the active cursor. More...
SDL_Cursor * | SDL_GetDefaultCursor (void)
| Return the default cursor. More...
void | SDL_FreeCursor (SDL_Cursor *cursor)
| Frees a cursor created with SDL_CreateCursor() or similar functions. More...
int | SDL_ShowCursor (int toggle)
| Toggle whether or not the cursor is shown. More...

## Variables

static SDL_Mouse | SDL_mouse
static SDL_bool | track_mouse_down = SDL_FALSE

## Function Documentation

## GetMouseClickState()

static SDL_MouseClickState* GetMouseClickState | ( | SDL_Mouse * | mouse,
|  | Uint8 | button
| ) |  |

static

Definition at line 475 of file SDL_mouse.c.

{
if (button >= mouse->num_clickstates) {
int i, count = button + 1;
SDL_MouseClickState *clickstate = (SDL_MouseClickState *)SDL_realloc(mouse->clickstate, count * sizeof(*mouse->clickstate));
if (!clickstate) {
return NULL;
}
mouse->clickstate = clickstate;
for (i = mouse->num_clickstates; i < count; ++i) {
SDL_zero(mouse->clickstate[i]);
}
mouse->num_clickstates = count;
}
return &mouse->clickstate[button];
}

References button, SDL_Mouse::clickstate, i, NULL, SDL_Mouse::num_clickstates, SDL_realloc, and SDL_zero.

Referenced by SDL_PrivateSendMouseButton().

## GetScaledMouseDelta()

static int GetScaledMouseDelta | ( | float | scale,
|  | int | value,
|  | float * | accum
| ) |  |

static

Definition at line 314 of file SDL_mouse.c.

{
if (scale != 1.0f) {
*accum += scale * value;
if (*accum >= 0.0f) {
value = (int)SDL_floor(*accum);
} else {
value = (int)SDL_ceil(*accum);
}
*accum -= value;
}
return value;
}

References SDL_ceil, and SDL_floor.

Referenced by SDL_PrivateSendMouseMotion().

## SDL_CaptureMouse()

int SDL_CaptureMouse | ( | SDL_bool | enabled | ) |

Capture the mouse, to track input outside an SDL window.

Parameters

  enabled | Whether or not to enable capturing

Capturing enables your app to obtain mouse events globally, instead of just within your window. Not all video targets support this function. When capturing is enabled, the current window will get all mouse events, but unlike relative mode, no change is made to the cursor and it is not restrained to your window.

This function may also deny mouse input to other windows–both those in your application and others on the system–so you should use this function sparingly, and in small bursts. For example, you might want to track the mouse while the user is dragging something, until the user releases a mouse button. It is not recommended that you capture the mouse for long periods of time, such as the entire time your app is running.

While captured, mouse events still report coordinates relative to the current (foreground) window, but those coordinates may be outside the bounds of the window (including negative values). Capturing is only allowed for the foreground window. If the window loses focus while capturing, the capture will be disabled automatically.

While capturing is enabled, the current window will have the SDL_WINDOW_MOUSE_CAPTURE flag set.

Returns
  0 on success, or -1 if not supported.

Definition at line 861 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Window *focusWindow;
SDL_bool isCaptured;
if (!mouse->CaptureMouse) {
return SDL_Unsupported();
}
focusWindow = SDL_GetKeyboardFocus();
isCaptured = focusWindow && (focusWindow->flags & SDL_WINDOW_MOUSE_CAPTURE);
if (isCaptured == enabled) {
return 0; /* already done! */
}
if (enabled) {
if (!focusWindow) {
return SDL_SetError("No window has focus");
} else if (mouse->CaptureMouse(focusWindow) == -1) {
return -1; /* CaptureMouse() should call SetError */
}
focusWindow->flags |= SDL_WINDOW_MOUSE_CAPTURE;
} else {
if (mouse->CaptureMouse(NULL) == -1) {
return -1; /* CaptureMouse() should call SetError */
}
focusWindow->flags &= ~SDL_WINDOW_MOUSE_CAPTURE;
}
return 0;
}

References SDL_Mouse::CaptureMouse, SDL_Window::flags, NULL, SDL_GetKeyboardFocus, SDL_GetMouse(), SDL_SetError, SDL_Unsupported, and SDL_WINDOW_MOUSE_CAPTURE.

Referenced by SDL_MouseQuit().

## SDL_CreateColorCursor()

SDL_Cursor* SDL_CreateColorCursor | ( | SDL_Surface * | surface,
|  | int | hot_x,
|  | int | hot_y
| ) |  |

Create a color cursor.

See also
  SDL_FreeCursor()

Definition at line 945 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Surface *temp = NULL;
SDL_Cursor *cursor;
if (!surface) {
SDL_SetError("Passed NULL cursor surface");
return NULL;
}
if (!mouse->CreateCursor) {
SDL_SetError("Cursors are not currently supported");
return NULL;
}
/* Sanity check the hot spot */
if ((hot_x < 0) || (hot_y < 0) ||
(hot_x >= surface->w) || (hot_y >= surface->h)) {
SDL_SetError("Cursor hot spot doesn't lie within cursor");
return NULL;
}
if (surface->format->format != SDL_PIXELFORMAT_ARGB8888) {
temp = SDL_ConvertSurfaceFormat(surface, SDL_PIXELFORMAT_ARGB8888, 0);
if (!temp) {
return NULL;
}
surface = temp;
}
cursor = mouse->CreateCursor(surface, hot_x, hot_y);
if (cursor) {
cursor->next = mouse->cursors;
mouse->cursors = cursor;
}
SDL_FreeSurface(temp);
return cursor;
}

References SDL_Mouse::CreateCursor, cursor, SDL_Mouse::cursors, hot_x, SDL_Cursor::next, NULL, SDL_ConvertSurfaceFormat, SDL_FreeSurface, SDL_GetMouse(), SDL_PIXELFORMAT_ARGB8888, and SDL_SetError.

Referenced by SDL_CreateCursor().

## SDL_CreateCursor()

SDL_Cursor* SDL_CreateCursor | ( | const Uint8 * | data,
|  | const Uint8 * | mask,
|  | int | w,
|  | int | h,
|  | int | hot_x,
|  | int | hot_y
| ) |  |

Create a cursor, using the specified bitmap data and mask (in MSB format).

The cursor width must be a multiple of 8 bits.

The cursor is created in black and white according to the following:

data | mask | resulting pixel on screen
0 | 1 | White
1 | 1 | Black
0 | 0 | Transparent
1 | 0 | Inverted color if possible, black if not.

See also
  SDL_FreeCursor()

Definition at line 896 of file SDL_mouse.c.

{
SDL_Surface *surface;
SDL_Cursor *cursor;
int x, y;
Uint32 *pixel;
Uint8 datab = 0, maskb = 0;
const Uint32 black = 0xFF000000;
const Uint32 white = 0xFFFFFFFF;
const Uint32 transparent = 0x00000000;
/* Make sure the width is a multiple of 8 */
w = ((w + 7) & ~7);
/* Create the surface from a bitmap */
surface = SDL_CreateRGBSurface(0, w, h, 32,
0x00FF0000,
0x0000FF00,
0x000000FF,
0xFF000000);
if (!surface) {
return NULL;
}
for (y = 0; y < h; ++y) {
pixel = (Uint32 *) ((Uint8 *) surface->pixels + y * surface->pitch);
for (x = 0; x < w; ++x) {
if ((x % 8) == 0) {
datab = *data++;
maskb = *mask++;
}
if (maskb & 0x80) {
*pixel++ = (datab & 0x80) ? black : white;
} else {
*pixel++ = (datab & 0x80) ? black : transparent;
}
datab <<= 1;
maskb <<= 1;
}
}
cursor = SDL_CreateColorCursor(surface, hot_x, hot_y);
SDL_FreeSurface(surface);
return cursor;
}

References cursor, hot_x, NULL, SDL_CreateColorCursor(), SDL_CreateRGBSurface, and SDL_FreeSurface.

## SDL_CreateSystemCursor()

SDL_Cursor* SDL_CreateSystemCursor | ( | SDL_SystemCursor | id | ) |

Create a system cursor.

See also
  SDL_FreeCursor()

Definition at line 988 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Cursor *cursor;
if (!mouse->CreateSystemCursor) {
SDL_SetError("CreateSystemCursor is not currently supported");
return NULL;
}
cursor = mouse->CreateSystemCursor(id);
if (cursor) {
cursor->next = mouse->cursors;
mouse->cursors = cursor;
}
return cursor;
}

References SDL_Mouse::CreateSystemCursor, cursor, SDL_Mouse::cursors, SDL_Cursor::next, NULL, SDL_GetMouse(), and SDL_SetError.

## SDL_FreeCursor()

void SDL_FreeCursor | ( | SDL_Cursor * | cursor | ) |

Frees a cursor created with SDL_CreateCursor() or similar functions.

See also
  SDL_CreateCursor()
  SDL_CreateColorCursor()
  SDL_CreateSystemCursor()

Definition at line 1074 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Cursor *curr, *prev;
if (!cursor) {
return;
}
if (cursor == mouse->def_cursor) {
return;
}
if (cursor == mouse->cur_cursor) {
SDL_SetCursor(mouse->def_cursor);
}
for (prev = NULL, curr = mouse->cursors; curr;
prev = curr, curr = curr->next) {
if (curr == cursor) {
if (prev) {
prev->next = curr->next;
} else {
mouse->cursors = curr->next;
}
if (mouse->FreeCursor) {
mouse->FreeCursor(curr);
}
return;
}
}
}

References SDL_Mouse::cur_cursor, cursor, SDL_Mouse::cursors, SDL_Mouse::def_cursor, SDL_Mouse::FreeCursor, SDL_Cursor::next, NULL, SDL_GetMouse(), and SDL_SetCursor().

Referenced by SDL_MouseQuit().

## SDL_GetCursor()

SDL_Cursor* SDL_GetCursor | ( | void |  | ) |

Return the active cursor.

Definition at line 1052 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (!mouse) {
return NULL;
}
return mouse->cur_cursor;
}

References SDL_Mouse::cur_cursor, NULL, and SDL_GetMouse().

## SDL_GetDefaultCursor()

SDL_Cursor* SDL_GetDefaultCursor | ( | void |  | ) |

Return the default cursor.

Definition at line 1063 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (!mouse) {
return NULL;
}
return mouse->def_cursor;
}

References SDL_Mouse::def_cursor, NULL, and SDL_GetMouse().

## SDL_GetGlobalMouseState()

Uint32 SDL_GetGlobalMouseState | ( | int * | x,
|  | int * | y
| ) |  |

Get the current state of the mouse, in relation to the desktop.

This works just like SDL_GetMouseState(), but the coordinates will be reported relative to the top-left of the desktop. This can be useful if you need to track the mouse outside of a specific window and SDL_CaptureMouse() doesn't fit your needs. For example, it could be useful if you need to track the mouse while dragging a window, where coordinates relative to a window might not be in sync at all times.

Note
  SDL_GetMouseState() returns the mouse position as SDL understands it from the last pump of the event queue. This function, however, queries the OS for the current mouse position, and as such, might be a slightly less efficient function. Unless you know what you're doing and have a good reason to use this function, you probably want SDL_GetMouseState() instead.

Parameters

  x | Returns the current X coord, relative to the desktop. Can be NULL.
  y | Returns the current Y coord, relative to the desktop. Can be NULL.

Returns
  The current button state as a bitmask, which can be tested using the SDL_BUTTON(X) macros.

See also
  SDL_GetMouseState

Definition at line 733 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
int tmpx, tmpy;
/* make sure these are never NULL for the backend implementations... */
if (!x) {
x = &tmpx;
}
if (!y) {
y = &tmpy;
}
*x = *y = 0;
if (!mouse->GetGlobalMouseState) {
return 0;
}
return mouse->GetGlobalMouseState(x, y);
}

References SDL_Mouse::GetGlobalMouseState, and SDL_GetMouse().

## SDL_GetMouse()

SDL_Mouse* SDL_GetMouse | ( | void |  | ) |

Definition at line 178 of file SDL_mouse.c.

{
return &SDL_mouse;
}

References SDL_mouse.

Referenced by SDL_CaptureMouse(), SDL_CreateColorCursor(), SDL_CreateSystemCursor(), SDL_FreeCursor(), SDL_GetCursor(), SDL_GetDefaultCursor(), SDL_GetGlobalMouseState(), SDL_GetMouseFocus(), SDL_GetMouseState(), SDL_GetRelativeMouseMode(), SDL_GetRelativeMouseState(), SDL_MouseInit(), SDL_MouseQuit(), SDL_OnWindowFocusGained(), SDL_PrivateSendMouseButton(), SDL_PrivateSendMouseMotion(), SDL_SendMouseMotion(), SDL_SendMouseWheel(), SDL_SendTouch(), SDL_SendTouchMotion(), SDL_SetCursor(), SDL_SetDefaultCursor(), SDL_SetMouseFocus(), SDL_SetRelativeMouseMode(), SDL_ShowCursor(), SDL_UpdateMouseFocus(), SDL_UpdateWindowGrab(), SDL_WarpMouseGlobal(), and SDL_WarpMouseInWindow().

## SDL_GetMouseFocus()

SDL_Window* SDL_GetMouseFocus | ( | void |  | ) |

Get the window which currently has mouse focus.

Definition at line 184 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
return mouse->focus;
}

References SDL_Mouse::focus, and SDL_GetMouse().

## SDL_GetMouseState()

Uint32 SDL_GetMouseState | ( | int * | x,
|  | int * | y
| ) |  |

Retrieve the current state of the mouse.

The current button state is returned as a button bitmask, which can be tested using the SDL_BUTTON(X) macros, and x and y are set to the mouse cursor position relative to the focus window for the currently selected mouse. You can pass NULL for either x or y.

Definition at line 703 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (x) {
*x = mouse->x;
}
if (y) {
*y = mouse->y;
}
return mouse->buttonstate;
}

References SDL_Mouse::buttonstate, SDL_GetMouse(), SDL_Mouse::x, and SDL_Mouse::y.

## SDL_GetRelativeMouseMode()

SDL_bool SDL_GetRelativeMouseMode | ( | void |  | ) |

Query whether relative mouse mode is enabled.

See also
  SDL_SetRelativeMouseMode()

Definition at line 853 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
return mouse->relative_mode;
}

References SDL_Mouse::relative_mode, and SDL_GetMouse().

## SDL_GetRelativeMouseState()

Uint32 SDL_GetRelativeMouseState | ( | int * | x,
|  | int * | y
| ) |  |

Retrieve the relative state of the mouse.

The current button state is returned as a button bitmask, which can be tested using the SDL_BUTTON(X) macros, and x and y are set to the mouse deltas since the last call to SDL_GetRelativeMouseState().

Definition at line 717 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (x) {
*x = mouse->xdelta;
}
if (y) {
*y = mouse->ydelta;
}
mouse->xdelta = 0;
mouse->ydelta = 0;
return mouse->buttonstate;
}

References SDL_Mouse::buttonstate, SDL_GetMouse(), SDL_Mouse::xdelta, and SDL_Mouse::ydelta.

## SDL_MouseDoubleClickRadiusChanged()

static void SDL_MouseDoubleClickRadiusChanged | ( | void * | userdata,
|  | const char * | name,
|  | const char * | oldValue,
|  | const char * | hint
| ) |  |

static

Definition at line 63 of file SDL_mouse.c.

{
SDL_Mouse *mouse = (SDL_Mouse *)userdata;
if (hint && *hint) {
mouse->double_click_radius = SDL_atoi(hint);
} else {
mouse->double_click_radius = 32; /* 32 pixels seems about right for touch interfaces */
}
}

References SDL_Mouse::double_click_radius, and SDL_atoi.

Referenced by SDL_MouseInit().

## SDL_MouseDoubleClickTimeChanged()

static void SDL_MouseDoubleClickTimeChanged | ( | void * | userdata,
|  | const char * | name,
|  | const char * | oldValue,
|  | const char * | hint
| ) |  |

static

Definition at line 47 of file SDL_mouse.c.

{
SDL_Mouse *mouse = (SDL_Mouse *)userdata;
if (hint && *hint) {
mouse->double_click_time = SDL_atoi(hint);
} else {
#ifdef __WIN32__
mouse->double_click_time = GetDoubleClickTime();
#else
mouse->double_click_time = 500;
#endif
}
}

References SDL_Mouse::double_click_time, and SDL_atoi.

Referenced by SDL_MouseInit().

## SDL_MouseInit()

int SDL_MouseInit | ( | void |  | ) |

Definition at line 135 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_zerop(mouse);
SDL_AddHintCallback(SDL_HINT_MOUSE_DOUBLE_CLICK_TIME,
SDL_MouseDoubleClickTimeChanged, mouse);
SDL_AddHintCallback(SDL_HINT_MOUSE_DOUBLE_CLICK_RADIUS,
SDL_MouseDoubleClickRadiusChanged, mouse);
SDL_AddHintCallback(SDL_HINT_MOUSE_NORMAL_SPEED_SCALE,
SDL_MouseNormalSpeedScaleChanged, mouse);
SDL_AddHintCallback(SDL_HINT_MOUSE_RELATIVE_SPEED_SCALE,
SDL_MouseRelativeSpeedScaleChanged, mouse);
SDL_AddHintCallback(SDL_HINT_TOUCH_MOUSE_EVENTS,
SDL_TouchMouseEventsChanged, mouse);
SDL_AddHintCallback(SDL_HINT_MOUSE_TOUCH_EVENTS,
SDL_MouseTouchEventsChanged, mouse);
mouse->was_touch_mouse_events = SDL_FALSE; /* no touch to mouse movement event pending */
mouse->cursor_shown = SDL_TRUE;
return (0);
}

References SDL_Mouse::cursor_shown, SDL_AddHintCallback, SDL_FALSE, SDL_GetMouse(), SDL_HINT_MOUSE_DOUBLE_CLICK_RADIUS, SDL_HINT_MOUSE_DOUBLE_CLICK_TIME, SDL_HINT_MOUSE_NORMAL_SPEED_SCALE, SDL_HINT_MOUSE_RELATIVE_SPEED_SCALE, SDL_HINT_MOUSE_TOUCH_EVENTS, SDL_HINT_TOUCH_MOUSE_EVENTS, SDL_MouseDoubleClickRadiusChanged(), SDL_MouseDoubleClickTimeChanged(), SDL_MouseNormalSpeedScaleChanged(), SDL_MouseRelativeSpeedScaleChanged(), SDL_MouseTouchEventsChanged(), SDL_TouchMouseEventsChanged(), SDL_TRUE, SDL_zerop, and SDL_Mouse::was_touch_mouse_events.

Referenced by SDL_VideoInit().

## SDL_MouseNormalSpeedScaleChanged()

static void SDL_MouseNormalSpeedScaleChanged | ( | void * | userdata,
|  | const char * | name,
|  | const char * | oldValue,
|  | const char * | hint
| ) |  |

static

Definition at line 75 of file SDL_mouse.c.

{
SDL_Mouse *mouse = (SDL_Mouse *)userdata;
if (hint && *hint) {
mouse->normal_speed_scale = (float)SDL_atof(hint);
} else {
mouse->normal_speed_scale = 1.0f;
}
}

References SDL_Mouse::normal_speed_scale, and SDL_atof.

Referenced by SDL_MouseInit(), and SDL_MouseQuit().

## SDL_MouseQuit()

void SDL_MouseQuit | ( | void |  | ) |

Definition at line 665 of file SDL_mouse.c.

{
SDL_Cursor *cursor, *next;
SDL_Mouse *mouse = SDL_GetMouse();
if (mouse->CaptureMouse) {
SDL_CaptureMouse(SDL_FALSE);
}
SDL_SetRelativeMouseMode(SDL_FALSE);
SDL_ShowCursor(1);
cursor = mouse->cursors;
while (cursor) {
next = cursor->next;
SDL_FreeCursor(cursor);
cursor = next;
}
mouse->cursors = NULL;
mouse->cur_cursor = NULL;
if (mouse->def_cursor && mouse->FreeCursor) {
mouse->FreeCursor(mouse->def_cursor);
mouse->def_cursor = NULL;
}
if (mouse->clickstate) {
SDL_free(mouse->clickstate);
mouse->clickstate = NULL;
}
SDL_DelHintCallback(SDL_HINT_MOUSE_NORMAL_SPEED_SCALE,
SDL_MouseNormalSpeedScaleChanged, mouse);
SDL_DelHintCallback(SDL_HINT_MOUSE_RELATIVE_SPEED_SCALE,
SDL_MouseRelativeSpeedScaleChanged, mouse);
}

References SDL_Mouse::CaptureMouse, SDL_Mouse::clickstate, SDL_Mouse::cur_cursor, cursor, SDL_Mouse::cursors, SDL_Mouse::def_cursor, SDL_Mouse::FreeCursor, SDL_Cursor::next, NULL, SDL_CaptureMouse(), SDL_DelHintCallback, SDL_FALSE, SDL_free, SDL_FreeCursor(), SDL_GetMouse(), SDL_HINT_MOUSE_NORMAL_SPEED_SCALE, SDL_HINT_MOUSE_RELATIVE_SPEED_SCALE, SDL_MouseNormalSpeedScaleChanged(), SDL_MouseRelativeSpeedScaleChanged(), SDL_SetRelativeMouseMode(), and SDL_ShowCursor().

Referenced by SDL_VideoQuit().

## SDL_MouseRelativeSpeedScaleChanged()

static void SDL_MouseRelativeSpeedScaleChanged | ( | void * | userdata,
|  | const char * | name,
|  | const char * | oldValue,
|  | const char * | hint
| ) |  |

static

Definition at line 87 of file SDL_mouse.c.

{
SDL_Mouse *mouse = (SDL_Mouse *)userdata;
if (hint && *hint) {
mouse->relative_speed_scale = (float)SDL_atof(hint);
} else {
mouse->relative_speed_scale = 1.0f;
}
}

References SDL_Mouse::relative_speed_scale, and SDL_atof.

Referenced by SDL_MouseInit(), and SDL_MouseQuit().

## SDL_MouseTouchEventsChanged()

static void SDL_MouseTouchEventsChanged | ( | void * | userdata,
|  | const char * | name,
|  | const char * | oldValue,
|  | const char * | hint
| ) |  |

static

Definition at line 111 of file SDL_mouse.c.

{
SDL_Mouse *mouse = (SDL_Mouse *)userdata;
if (hint == NULL || *hint == '\0') {
/* Default */
#if defined(__ANDROID__) || (defined(__IPHONEOS__) && !defined(__TVOS__))
mouse->mouse_touch_events = SDL_TRUE;
#else
mouse->mouse_touch_events = SDL_FALSE;
#endif
} else if (*hint == '1' || SDL_strcasecmp(hint, "true") == 0) {
mouse->mouse_touch_events = SDL_TRUE;
} else {
mouse->mouse_touch_events = SDL_FALSE;
}
if (mouse->mouse_touch_events) {
SDL_AddTouch(SDL_MOUSE_TOUCHID, SDL_TOUCH_DEVICE_DIRECT, "mouse_input");
}
}

References SDL_Mouse::mouse_touch_events, NULL, SDL_AddTouch(), SDL_FALSE, SDL_MOUSE_TOUCHID, SDL_strcasecmp, SDL_TOUCH_DEVICE_DIRECT, and SDL_TRUE.

Referenced by SDL_MouseInit().

## SDL_PrivateSendMouseButton()

static int SDL_PrivateSendMouseButton | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | Uint8 | state,
|  | Uint8 | button,
|  | int | clicks
| ) |  |

static

Definition at line 494 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
int posted;
Uint32 type;
Uint32 buttonstate = mouse->buttonstate;
/* SDL_HINT_MOUSE_TOUCH_EVENTS: controlling whether mouse events should generate synthetic touch events */
if (mouse->mouse_touch_events) {
if (mouseID != SDL_TOUCH_MOUSEID && button == SDL_BUTTON_LEFT) {
if (state == SDL_PRESSED) {
track_mouse_down = SDL_TRUE;
} else {
track_mouse_down = SDL_FALSE;
}
if (window) {
float fx = (float)mouse->x / (float)window->w;
float fy = (float)mouse->y / (float)window->h;
SDL_SendTouch(SDL_MOUSE_TOUCHID, 0, track_mouse_down, fx, fy, 1.0f);
}
}
}
/* SDL_HINT_TOUCH_MOUSE_EVENTS: if not set, discard synthetic mouse events coming from platform layer */
if (mouse->touch_mouse_events == 0) {
if (mouseID == SDL_TOUCH_MOUSEID) {
return 0;
}
}
/* Figure out which event to perform */
switch (state) {
case SDL_PRESSED:
type = SDL_MOUSEBUTTONDOWN;
buttonstate |= SDL_BUTTON(button);
break;
case SDL_RELEASED:
type = SDL_MOUSEBUTTONUP;
buttonstate &= ~SDL_BUTTON(button);
break;
default:
/* Invalid state -- bail */
return 0;
}
/* We do this after calculating buttonstate so button presses gain focus */
if (window && state == SDL_PRESSED) {
SDL_UpdateMouseFocus(window, mouse->x, mouse->y, buttonstate, SDL_TRUE);
}
if (buttonstate == mouse->buttonstate) {
/* Ignore this event, no state change */
return 0;
}
mouse->buttonstate = buttonstate;
if (clicks < 0) {
SDL_MouseClickState *clickstate = GetMouseClickState(mouse, button);
if (clickstate) {
if (state == SDL_PRESSED) {
Uint32 now = SDL_GetTicks();
if (SDL_TICKS_PASSED(now, clickstate->last_timestamp + mouse->double_click_time) ||
SDL_abs(mouse->x - clickstate->last_x) > mouse->double_click_radius ||
SDL_abs(mouse->y - clickstate->last_y) > mouse->double_click_radius) {
clickstate->click_count = 0;
}
clickstate->last_timestamp = now;
clickstate->last_x = mouse->x;
clickstate->last_y = mouse->y;
if (clickstate->click_count < 255) {
++clickstate->click_count;
}
}
clicks = clickstate->click_count;
} else {
clicks = 1;
}
}
/* Post the event, if desired */
posted = 0;
if (SDL_GetEventState(type) == SDL_ENABLE) {
SDL_Event event;
event.type = type;
event.button.windowID = mouse->focus ? mouse->focus->id : 0;
event.button.which = mouseID;
event.button.state = state;
event.button.button = button;
event.button.clicks = (Uint8) SDL_min(clicks, 255);
event.button.x = mouse->x;
event.button.y = mouse->y;
posted = (SDL_PushEvent(&event) > 0);
}
/* We do this after dispatching event so button releases can lose focus */
if (window && state == SDL_RELEASED) {
SDL_UpdateMouseFocus(window, mouse->x, mouse->y, buttonstate, SDL_TRUE);
}
return posted;
}

References button, SDL_Mouse::buttonstate, SDL_MouseClickState::click_count, SDL_Mouse::double_click_radius, SDL_Mouse::double_click_time, SDL_Mouse::focus, GetMouseClickState(), SDL_Window::id, SDL_MouseClickState::last_timestamp, SDL_MouseClickState::last_x, SDL_MouseClickState::last_y, SDL_Mouse::mouse_touch_events, SDL_abs, SDL_BUTTON, SDL_BUTTON_LEFT, SDL_ENABLE, SDL_FALSE, SDL_GetEventState, SDL_GetMouse(), SDL_GetTicks(), SDL_min, SDL_MOUSE_TOUCHID, SDL_MOUSEBUTTONDOWN, SDL_MOUSEBUTTONUP, SDL_PRESSED, SDL_PushEvent, SDL_RELEASED, SDL_SendTouch(), SDL_TICKS_PASSED, SDL_TOUCH_MOUSEID, SDL_TRUE, SDL_UpdateMouseFocus(), state, SDL_Mouse::touch_mouse_events, track_mouse_down, SDL_Mouse::x, and SDL_Mouse::y.

Referenced by SDL_SendMouseButton(), and SDL_SendMouseButtonClicks().

## SDL_PrivateSendMouseMotion()

static int SDL_PrivateSendMouseMotion | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | int | relative,
|  | int | x,
|  | int | y
| ) |  |

static

Definition at line 329 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
int posted;
int xrel;
int yrel;
/* SDL_HINT_MOUSE_TOUCH_EVENTS: controlling whether mouse events should generate synthetic touch events */
if (mouse->mouse_touch_events) {
if (mouseID != SDL_TOUCH_MOUSEID && !relative && track_mouse_down) {
if (window) {
float fx = (float)x / (float)window->w;
float fy = (float)y / (float)window->h;
SDL_SendTouchMotion(SDL_MOUSE_TOUCHID, 0, fx, fy, 1.0f);
}
}
}
/* SDL_HINT_TOUCH_MOUSE_EVENTS: if not set, discard synthetic mouse events coming from platform layer */
if (mouse->touch_mouse_events == 0) {
if (mouseID == SDL_TOUCH_MOUSEID) {
return 0;
}
}
if (mouseID != SDL_TOUCH_MOUSEID && mouse->relative_mode_warp) {
int center_x = 0, center_y = 0;
SDL_GetWindowSize(window, &center_x, &center_y);
center_x /= 2;
center_y /= 2;
if (x == center_x && y == center_y) {
mouse->last_x = center_x;
mouse->last_y = center_y;
return 0;
}
SDL_WarpMouseInWindow(window, center_x, center_y);
}
if (relative) {
if (mouse->relative_mode) {
x = GetScaledMouseDelta(mouse->relative_speed_scale, x, &mouse->scale_accum_x);
y = GetScaledMouseDelta(mouse->relative_speed_scale, y, &mouse->scale_accum_y);
} else {
x = GetScaledMouseDelta(mouse->normal_speed_scale, x, &mouse->scale_accum_x);
y = GetScaledMouseDelta(mouse->normal_speed_scale, y, &mouse->scale_accum_y);
}
xrel = x;
yrel = y;
x = (mouse->last_x + xrel);
y = (mouse->last_y + yrel);
} else {
xrel = x - mouse->last_x;
yrel = y - mouse->last_y;
}
/* Drop events that don't change state */
if (!xrel && !yrel) {
#ifdef DEBUG_MOUSE
printf("Mouse event didn't change state - dropped!\n");
#endif
return 0;
}
/* Ignore relative motion when first positioning the mouse */
if (!mouse->has_position) {
xrel = 0;
yrel = 0;
mouse->has_position = SDL_TRUE;
}
/* Ignore relative motion positioning the first touch */
if (mouseID == SDL_TOUCH_MOUSEID && !mouse->buttonstate) {
xrel = 0;
yrel = 0;
}
/* Update internal mouse coordinates */
if (!mouse->relative_mode) {
mouse->x = x;
mouse->y = y;
} else {
mouse->x += xrel;
mouse->y += yrel;
}
/* make sure that the pointers find themselves inside the windows,
unless we have the mouse captured. */
if (window && ((window->flags & SDL_WINDOW_MOUSE_CAPTURE) == 0)) {
int x_max = 0, y_max = 0;
/* !!! FIXME: shouldn't this be (window) instead of (mouse->focus)? */
SDL_GetWindowSize(mouse->focus, &x_max, &y_max);
--x_max;
--y_max;
if (mouse->x > x_max) {
mouse->x = x_max;
}
if (mouse->x < 0) {
mouse->x = 0;
}
if (mouse->y > y_max) {
mouse->y = y_max;
}
if (mouse->y < 0) {
mouse->y = 0;
}
}
mouse->xdelta += xrel;
mouse->ydelta += yrel;
/* Move the mouse cursor, if needed */
if (mouse->cursor_shown && !mouse->relative_mode &&
mouse->MoveCursor && mouse->cur_cursor) {
mouse->MoveCursor(mouse->cur_cursor);
}
/* Post the event, if desired */
posted = 0;
if (SDL_GetEventState(SDL_MOUSEMOTION) == SDL_ENABLE) {
SDL_Event event;
event.motion.type = SDL_MOUSEMOTION;
event.motion.windowID = mouse->focus ? mouse->focus->id : 0;
event.motion.which = mouseID;
/* Set us pending (or clear during a normal mouse movement event) as having triggered */
mouse->was_touch_mouse_events = (mouseID == SDL_TOUCH_MOUSEID)? SDL_TRUE : SDL_FALSE;
event.motion.state = mouse->buttonstate;
event.motion.x = mouse->x;
event.motion.y = mouse->y;
event.motion.xrel = xrel;
event.motion.yrel = yrel;
posted = (SDL_PushEvent(&event) > 0);
}
if (relative) {
mouse->last_x = mouse->x;
mouse->last_y = mouse->y;
} else {
/* Use unclamped values if we're getting events outside the window */
mouse->last_x = x;
mouse->last_y = y;
}
return posted;
}

References SDL_Mouse::buttonstate, SDL_Mouse::cur_cursor, SDL_Mouse::cursor_shown, SDL_Mouse::focus, GetScaledMouseDelta(), SDL_Mouse::has_position, SDL_Window::id, SDL_Mouse::last_x, SDL_Mouse::last_y, SDL_Mouse::mouse_touch_events, SDL_Mouse::MoveCursor, SDL_Mouse::normal_speed_scale, SDL_Mouse::relative_mode, SDL_Mouse::relative_mode_warp, SDL_Mouse::relative_speed_scale, SDL_Mouse::scale_accum_x, SDL_Mouse::scale_accum_y, SDL_ENABLE, SDL_FALSE, SDL_GetEventState, SDL_GetMouse(), SDL_GetWindowSize, SDL_MOUSE_TOUCHID, SDL_MOUSEMOTION, SDL_PushEvent, SDL_SendTouchMotion(), SDL_TOUCH_MOUSEID, SDL_TRUE, SDL_WarpMouseInWindow(), SDL_WINDOW_MOUSE_CAPTURE, SDL_Mouse::touch_mouse_events, track_mouse_down, SDL_Mouse::was_touch_mouse_events, SDL_Mouse::x, SDL_Mouse::xdelta, SDL_Mouse::y, and SDL_Mouse::ydelta.

Referenced by SDL_SendMouseMotion(), and SDL_UpdateMouseFocus().

## SDL_SendMouseButton()

int SDL_SendMouseButton | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | Uint8 | state,
|  | Uint8 | button
| ) |  |

Definition at line 605 of file SDL_mouse.c.

{
return SDL_PrivateSendMouseButton(window, mouseID, state, button, -1);
}

References button, SDL_PrivateSendMouseButton(), and state.

Referenced by SDL_BApp::_HandleMouseButton(), and SDL_SendTouch().

## SDL_SendMouseButtonClicks()

int SDL_SendMouseButtonClicks | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | Uint8 | state,
|  | Uint8 | button,
|  | int | clicks
| ) |  |

Definition at line 598 of file SDL_mouse.c.

{
clicks = SDL_max(clicks, 0);
return SDL_PrivateSendMouseButton(window, mouseID, state, button, clicks);
}

References button, SDL_max, SDL_PrivateSendMouseButton(), and state.

## SDL_SendMouseMotion()

int SDL_SendMouseMotion | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | int | relative,
|  | int | x,
|  | int | y
| ) |  |

Definition at line 301 of file SDL_mouse.c.

{
if (window && !relative) {
SDL_Mouse *mouse = SDL_GetMouse();
if (!SDL_UpdateMouseFocus(window, x, y, mouse->buttonstate, (mouseID == SDL_TOUCH_MOUSEID) ? SDL_FALSE : SDL_TRUE)) {
return 0;
}
}
return SDL_PrivateSendMouseMotion(window, mouseID, relative, x, y);
}

References SDL_Mouse::buttonstate, SDL_FALSE, SDL_GetMouse(), SDL_PrivateSendMouseMotion(), SDL_TOUCH_MOUSEID, SDL_TRUE, and SDL_UpdateMouseFocus().

Referenced by SDL_BApp::_HandleMouseMove(), SDL_SendTouch(), SDL_SendTouchMotion(), and SDL_WarpMouseInWindow().

## SDL_SendMouseWheel()

int SDL_SendMouseWheel | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | float | x,
|  | float | y,
|  | SDL_MouseWheelDirection | direction
| ) |  |

Definition at line 611 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
int posted;
int integral_x, integral_y;
if (window) {
SDL_SetMouseFocus(window);
}
if (x == 0.0f && y == 0.0f) {
return 0;
}
mouse->accumulated_wheel_x += x;
if (mouse->accumulated_wheel_x > 0) {
integral_x = (int)SDL_floor(mouse->accumulated_wheel_x);
} else if (mouse->accumulated_wheel_x < 0) {
integral_x = (int)SDL_ceil(mouse->accumulated_wheel_x);
} else {
integral_x = 0;
}
mouse->accumulated_wheel_x -= integral_x;
mouse->accumulated_wheel_y += y;
if (mouse->accumulated_wheel_y > 0) {
integral_y = (int)SDL_floor(mouse->accumulated_wheel_y);
} else if (mouse->accumulated_wheel_y < 0) {
integral_y = (int)SDL_ceil(mouse->accumulated_wheel_y);
} else {
integral_y = 0;
}
mouse->accumulated_wheel_y -= integral_y;
/* Post the event, if desired */
posted = 0;
if (SDL_GetEventState(SDL_MOUSEWHEEL) == SDL_ENABLE) {
SDL_Event event;
event.type = SDL_MOUSEWHEEL;
event.wheel.windowID = mouse->focus ? mouse->focus->id : 0;
event.wheel.which = mouseID;
#if 0 /* Uncomment this when it goes in for SDL 2.1 */
event.wheel.preciseX = x;
event.wheel.preciseY = y;
#endif
event.wheel.x = integral_x;
event.wheel.y = integral_y;
event.wheel.direction = (Uint32)direction;
posted = (SDL_PushEvent(&event) > 0);
}
return posted;
}

References SDL_Mouse::accumulated_wheel_x, SDL_Mouse::accumulated_wheel_y, SDL_Mouse::focus, SDL_Window::id, SDL_ceil, SDL_ENABLE, SDL_floor, SDL_GetEventState, SDL_GetMouse(), SDL_MOUSEWHEEL, SDL_PushEvent, and SDL_SetMouseFocus().

Referenced by SDL_BApp::_HandleMouseWheel().

## SDL_SetCursor()

void SDL_SetCursor | ( | SDL_Cursor * | cursor | ) |

Set the active cursor.

Definition at line 1012 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
/* Set the new cursor */
if (cursor) {
/* Make sure the cursor is still valid for this mouse */
if (cursor != mouse->def_cursor) {
SDL_Cursor *found;
for (found = mouse->cursors; found; found = found->next) {
if (found == cursor) {
break;
}
}
if (!found) {
SDL_SetError("Cursor not associated with the current mouse");
return;
}
}
mouse->cur_cursor = cursor;
} else {
if (mouse->focus) {
cursor = mouse->cur_cursor;
} else {
cursor = mouse->def_cursor;
}
}
if (cursor && mouse->cursor_shown && !mouse->relative_mode) {
if (mouse->ShowCursor) {
mouse->ShowCursor(cursor);
}
} else {
if (mouse->ShowCursor) {
mouse->ShowCursor(NULL);
}
}
}

References SDL_Mouse::cur_cursor, cursor, SDL_Mouse::cursor_shown, SDL_Mouse::cursors, SDL_Mouse::def_cursor, SDL_Mouse::focus, SDL_Cursor::next, NULL, SDL_Mouse::relative_mode, SDL_GetMouse(), SDL_SetError, and SDL_Mouse::ShowCursor.

Referenced by SDL_FreeCursor(), SDL_SetDefaultCursor(), SDL_SetMouseFocus(), SDL_SetRelativeMouseMode(), and SDL_ShowCursor().

## SDL_SetDefaultCursor()

void SDL_SetDefaultCursor | ( | SDL_Cursor * | cursor | ) |

Definition at line 167 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
mouse->def_cursor = cursor;
if (!mouse->cur_cursor) {
SDL_SetCursor(cursor);
}
}

References SDL_Mouse::cur_cursor, cursor, SDL_Mouse::def_cursor, SDL_GetMouse(), and SDL_SetCursor().

## SDL_SetMouseFocus()

void SDL_SetMouseFocus | ( | SDL_Window * | window | ) |

Definition at line 211 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (mouse->focus == window) {
return;
}
/* Actually, this ends up being a bad idea, because most operating
systems have an implicit grab when you press the mouse button down
so you can drag things out of the window and then get the mouse up
when it happens. So, #if 0...
*/
#if 0
if (mouse->focus && !window) {
/* We won't get anymore mouse messages, so reset mouse state */
SDL_ResetMouse();
}
#endif
/* See if the current window has lost focus */
if (mouse->focus) {
SDL_SendWindowEvent(mouse->focus, SDL_WINDOWEVENT_LEAVE, 0, 0);
}
mouse->focus = window;
mouse->has_position = SDL_FALSE;
if (mouse->focus) {
SDL_SendWindowEvent(mouse->focus, SDL_WINDOWEVENT_ENTER, 0, 0);
}
/* Update cursor visibility */
SDL_SetCursor(NULL);
}

References SDL_Mouse::focus, SDL_Mouse::has_position, NULL, SDL_FALSE, SDL_GetMouse(), SDL_SendWindowEvent(), SDL_SetCursor(), SDL_WINDOWEVENT_ENTER, and SDL_WINDOWEVENT_LEAVE.

Referenced by SDL_BApp::_HandleMouseFocus(), SDL_DestroyWindow(), SDL_OnWindowFocusGained(), SDL_SendMouseWheel(), SDL_SetRelativeMouseMode(), and SDL_UpdateMouseFocus().

## SDL_SetRelativeMouseMode()

int SDL_SetRelativeMouseMode | ( | SDL_bool | enabled | ) |

Set relative mouse mode.

Parameters

  enabled | Whether or not to enable relative mode

Returns
  0 on success, or -1 if relative mode is not supported.

While the mouse is in relative mode, the cursor is hidden, and the driver will try to report continuous motion in the current window. Only relative motion events will be delivered, the mouse position will not change.

Note
  This function will flush any pending mouse motion.

See also
  SDL_GetRelativeMouseMode()

Definition at line 799 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Window *focusWindow = SDL_GetKeyboardFocus();
if (enabled == mouse->relative_mode) {
return 0;
}
/* Set the relative mode */
if (!enabled && mouse->relative_mode_warp) {
mouse->relative_mode_warp = SDL_FALSE;
} else if (enabled && ShouldUseRelativeModeWarp(mouse)) {
mouse->relative_mode_warp = SDL_TRUE;
} else if (!mouse->SetRelativeMouseMode || mouse->SetRelativeMouseMode(enabled) < 0) {
if (enabled) {
/* Fall back to warp mode if native relative mode failed */
if (!mouse->WarpMouse) {
return SDL_SetError("No relative mode implementation available");
}
mouse->relative_mode_warp = SDL_TRUE;
}
}
mouse->relative_mode = enabled;
mouse->scale_accum_x = 0.0f;
mouse->scale_accum_y = 0.0f;
if (enabled && focusWindow) {
/* Center it in the focused window to prevent clicks from going through
* to background windows.
*/
SDL_SetMouseFocus(focusWindow);
SDL_WarpMouseInWindow(focusWindow, focusWindow->w/2, focusWindow->h/2);
}
if (mouse->focus) {
SDL_UpdateWindowGrab(mouse->focus);
/* Put the cursor back to where the application expects it */
if (!enabled) {
SDL_WarpMouseInWindow(mouse->focus, mouse->x, mouse->y);
}
}
/* Flush pending mouse motion - ideally we would pump events, but that's not always safe */
SDL_FlushEvent(SDL_MOUSEMOTION);
/* Update cursor visibility */
SDL_SetCursor(NULL);
return 0;
}

References SDL_Mouse::focus, SDL_Window::h, NULL, SDL_Mouse::relative_mode, SDL_Mouse::relative_mode_warp, SDL_Mouse::scale_accum_x, SDL_Mouse::scale_accum_y, SDL_FALSE, SDL_FlushEvent, SDL_GetKeyboardFocus, SDL_GetMouse(), SDL_MOUSEMOTION, SDL_SetCursor(), SDL_SetError, SDL_SetMouseFocus(), SDL_TRUE, SDL_UpdateWindowGrab(), SDL_WarpMouseInWindow(), SDL_Mouse::SetRelativeMouseMode, ShouldUseRelativeModeWarp(), SDL_Window::w, SDL_Mouse::WarpMouse, SDL_Mouse::x, and SDL_Mouse::y.

Referenced by SDL_MouseQuit().

## SDL_ShowCursor()

int SDL_ShowCursor | ( | int | toggle | ) |

Toggle whether or not the cursor is shown.

Parameters

  toggle | 1 to show the cursor, 0 to hide it, -1 to query the current state.

Returns
  1 if the cursor is shown, or 0 if the cursor is hidden.

Definition at line 1108 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_bool shown;
if (!mouse) {
return 0;
}
shown = mouse->cursor_shown;
if (toggle >= 0) {
if (toggle) {
mouse->cursor_shown = SDL_TRUE;
} else {
mouse->cursor_shown = SDL_FALSE;
}
if (mouse->cursor_shown != shown) {
SDL_SetCursor(NULL);
}
}
return shown;
}

References SDL_Mouse::cursor_shown, NULL, SDL_FALSE, SDL_GetMouse(), SDL_SetCursor(), and SDL_TRUE.

Referenced by SDL_MouseQuit().

## SDL_TouchMouseEventsChanged()

static void SDL_TouchMouseEventsChanged | ( | void * | userdata,
|  | const char * | name,
|  | const char * | oldValue,
|  | const char * | hint
| ) |  |

static

Definition at line 99 of file SDL_mouse.c.

{
SDL_Mouse *mouse = (SDL_Mouse *)userdata;
if (hint && (*hint == '0' || SDL_strcasecmp(hint, "false") == 0)) {
mouse->touch_mouse_events = SDL_FALSE;
} else {
mouse->touch_mouse_events = SDL_TRUE;
}
}

References SDL_FALSE, SDL_strcasecmp, SDL_TRUE, and SDL_Mouse::touch_mouse_events.

Referenced by SDL_MouseInit().

## SDL_UpdateMouseFocus()

static SDL_bool SDL_UpdateMouseFocus | ( | SDL_Window * | window,
|  | int | x,
|  | int | y,
|  | Uint32 | buttonstate,
|  | SDL_bool | send_mouse_motion
| ) |  |

static

Definition at line 249 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_bool inWindow = SDL_TRUE;
if (window && ((window->flags & SDL_WINDOW_MOUSE_CAPTURE) == 0)) {
int w, h;
SDL_GetWindowSize(window, &w, &h);
if (x < 0 || y < 0 || x >= w || y >= h) {
inWindow = SDL_FALSE;
}
}
/* Linux doesn't give you mouse events outside your window unless you grab
the pointer.
Windows doesn't give you mouse events outside your window unless you call
SetCapture().
Both of these are slightly scary changes, so for now we'll punt and if the
mouse leaves the window you'll lose mouse focus and reset button state.
*/
#ifdef SUPPORT_DRAG_OUTSIDE_WINDOW
if (!inWindow && !buttonstate) {
#else
if (!inWindow) {
#endif
if (window == mouse->focus) {
#ifdef DEBUG_MOUSE
printf("Mouse left window, synthesizing move & focus lost event\n");
#endif
if (send_mouse_motion) {
SDL_PrivateSendMouseMotion(window, mouse->mouseID, 0, x, y);
}
SDL_SetMouseFocus(NULL);
}
return SDL_FALSE;
}
if (window != mouse->focus) {
#ifdef DEBUG_MOUSE
printf("Mouse entered window, synthesizing focus gain & move event\n");
#endif
SDL_SetMouseFocus(window);
if (send_mouse_motion) {
SDL_PrivateSendMouseMotion(window, mouse->mouseID, 0, x, y);
}
}
return SDL_TRUE;
}

References SDL_Mouse::focus, SDL_Mouse::mouseID, NULL, SDL_FALSE, SDL_GetMouse(), SDL_GetWindowSize, SDL_PrivateSendMouseMotion(), SDL_SetMouseFocus(), SDL_TRUE, and SDL_WINDOW_MOUSE_CAPTURE.

Referenced by SDL_PrivateSendMouseButton(), and SDL_SendMouseMotion().

## SDL_WarpMouseGlobal()

int SDL_WarpMouseGlobal | ( | int | x,
|  | int | y
| ) |  |

Moves the mouse to the given position in global screen space.

Parameters

  x | The x coordinate
  y | The y coordinate

Returns
  0 on success, -1 on error (usually: unsupported by a platform).

Note
  This function generates a mouse motion event

Definition at line 776 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (mouse->WarpMouseGlobal) {
return mouse->WarpMouseGlobal(x, y);
}
return SDL_Unsupported();
}

References SDL_GetMouse(), SDL_Unsupported, and SDL_Mouse::WarpMouseGlobal.

## SDL_WarpMouseInWindow()

void SDL_WarpMouseInWindow | ( | SDL_Window * | window,
|  | int | x,
|  | int | y
| ) |  |

Moves the mouse to the given position within the window.

Parameters

  window | The window to move the mouse into, or NULL for the current mouse focus
  x | The x coordinate within the window
  y | The y coordinate within the window

Note
  This function generates a mouse motion event

Definition at line 756 of file SDL_mouse.c.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (window == NULL) {
window = mouse->focus;
}
if (window == NULL) {
return;
}
if (mouse->WarpMouse) {
mouse->WarpMouse(window, x, y);
} else {
SDL_SendMouseMotion(window, mouse->mouseID, 0, x, y);
}
}

References SDL_Mouse::focus, SDL_Mouse::mouseID, NULL, SDL_GetMouse(), SDL_SendMouseMotion(), and SDL_Mouse::WarpMouse.

Referenced by SDL_PrivateSendMouseMotion(), and SDL_SetRelativeMouseMode().

## ShouldUseRelativeModeWarp()

static SDL_bool ShouldUseRelativeModeWarp | ( | SDL_Mouse * | mouse | ) |

static

Definition at line 788 of file SDL_mouse.c.

{
if (!mouse->WarpMouse) {
/* Need this functionality for relative mode warp implementation */
return SDL_FALSE;
}
return SDL_GetHintBoolean(SDL_HINT_MOUSE_RELATIVE_MODE_WARP, SDL_FALSE);
}

References SDL_FALSE, SDL_GetHintBoolean, SDL_HINT_MOUSE_RELATIVE_MODE_WARP, and SDL_Mouse::WarpMouse.

Referenced by SDL_SetRelativeMouseMode().

## Variable Documentation

## SDL_mouse

SDL_Mouse SDL_mouse

static

Definition at line 38 of file SDL_mouse.c.

Referenced by SDL_GetMouse().

## track_mouse_down

SDL_bool track_mouse_down = SDL_FALSE

static

Definition at line 41 of file SDL_mouse.c.

Referenced by SDL_PrivateSendMouseButton(), and SDL_PrivateSendMouseMotion().

SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:178
SDL_zero
#define SDL_zero(x)
Definition: SDL_stdinc.h:416
SDL_WINDOW_MOUSE_CAPTURE
@ SDL_WINDOW_MOUSE_CAPTURE
Definition: SDL_video.h:116
ShouldUseRelativeModeWarp
static SDL_bool ShouldUseRelativeModeWarp(SDL_Mouse *mouse)
Definition: SDL_mouse.c:788
SDL_TOUCH_DEVICE_DIRECT
@ SDL_TOUCH_DEVICE_DIRECT
Definition: SDL_touch.h:47
SDL_Mouse::WarpMouseGlobal
int(* WarpMouseGlobal)(int x, int y)
Definition: SDL_mouse_c.h:64
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:203
SDL_Mouse::CaptureMouse
int(* CaptureMouse)(SDL_Window *window)
Definition: SDL_mouse_c.h:70
SDL_Mouse::buttonstate
Uint32 buttonstate
Definition: SDL_mouse_c.h:85
mask
GLenum GLint GLuint mask
Definition: SDL_opengl_glext.h:657
scale
GLenum GLenum GLenum GLenum GLenum scale
Definition: SDL_opengl_glext.h:9375
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:70
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_FlushEvent
#define SDL_FlushEvent
Definition: SDL_dynapi_overrides.h:120
SDL_ConvertSurfaceFormat
#define SDL_ConvertSurfaceFormat
Definition: SDL_dynapi_overrides.h:464
SDL_abs
#define SDL_abs
Definition: SDL_dynapi_overrides.h:381
SDL_Mouse::scale_accum_y
float scale_accum_y
Definition: SDL_mouse_c.h:92
SDL_HINT_TOUCH_MOUSE_EVENTS
#define SDL_HINT_TOUCH_MOUSE_EVENTS
A variable controlling whether touch events should generate synthetic mouse events.
Definition: SDL_hints.h:316
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:103
SDL_ceil
#define SDL_ceil
Definition: SDL_dynapi_overrides.h:426
NULL
#define NULL
Definition: begin_code.h:167
surface
EGLSurface surface
Definition: eglext.h:248
SDL_TouchMouseEventsChanged
static void SDL_TouchMouseEventsChanged(void *userdata, const char *name, const char *oldValue, const char *hint)
Definition: SDL_mouse.c:99
SDL_PrivateSendMouseMotion
static int SDL_PrivateSendMouseMotion(SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
Definition: SDL_mouse.c:329
SDL_zerop
#define SDL_zerop(x)
Definition: SDL_stdinc.h:417
SDL_Mouse::scale_accum_x
float scale_accum_x
Definition: SDL_mouse_c.h:91
SDL_MouseDoubleClickTimeChanged
static void SDL_MouseDoubleClickTimeChanged(void *userdata, const char *name, const char *oldValue, const char *hint)
Definition: SDL_mouse.c:47
SDL_WINDOWEVENT_ENTER
@ SDL_WINDOWEVENT_ENTER
Definition: SDL_video.h:163
SDL_CreateColorCursor
SDL_Cursor * SDL_CreateColorCursor(SDL_Surface *surface, int hot_x, int hot_y)
Create a color cursor.
Definition: SDL_mouse.c:945
SDL_Mouse::touch_mouse_events
SDL_bool touch_mouse_events
Definition: SDL_mouse_c.h:95
SDL_MouseClickState
Definition: SDL_mouse_c.h:36
count
GLuint GLuint GLsizei count
Definition: SDL_opengl.h:1571
SDL_Mouse::double_click_radius
int double_click_radius
Definition: SDL_mouse_c.h:94
SDL_Mouse::normal_speed_scale
float normal_speed_scale
Definition: SDL_mouse_c.h:89
SDL_MouseNormalSpeedScaleChanged
static void SDL_MouseNormalSpeedScaleChanged(void *userdata, const char *name, const char *oldValue, const char *hint)
Definition: SDL_mouse.c:75
SDL_Mouse::accumulated_wheel_x
float accumulated_wheel_x
Definition: SDL_mouse_c.h:83
SDL_Mouse::y
int y
Definition: SDL_mouse_c.h:79
SDL_MOUSEBUTTONUP
@ SDL_MOUSEBUTTONUP
Definition: SDL_events.h:107
SDL_realloc
#define SDL_realloc
Definition: SDL_dynapi_overrides.h:376
SDL_HINT_MOUSE_DOUBLE_CLICK_RADIUS
#define SDL_HINT_MOUSE_DOUBLE_CLICK_RADIUS
A variable setting the double click radius, in pixels.
Definition: SDL_hints.h:273
SDL_SetCursor
void SDL_SetCursor(SDL_Cursor *cursor)
Set the active cursor.
Definition: SDL_mouse.c:1012
SDL_floor
#define SDL_floor
Definition: SDL_dynapi_overrides.h:431
SDL_Mouse::SetRelativeMouseMode
int(* SetRelativeMouseMode)(SDL_bool enabled)
Definition: SDL_mouse_c.h:67
SDL_ENABLE
#define SDL_ENABLE
Definition: SDL_events.h:759
SDL_SendTouch
int SDL_SendTouch(SDL_TouchID id, SDL_FingerID fingerid, SDL_bool down, float x, float y, float pressure)
Definition: SDL_touch.c:242
SDL_RELEASED
#define SDL_RELEASED
Definition: SDL_events.h:49
h
GLfloat GLfloat GLfloat GLfloat h
Definition: SDL_opengl_glext.h:1946
SDL_SetMouseFocus
void SDL_SetMouseFocus(SDL_Window *window)
Definition: SDL_mouse.c:211
SDL_SendTouchMotion
int SDL_SendTouchMotion(SDL_TouchID id, SDL_FingerID fingerid, float x, float y, float pressure)
Definition: SDL_touch.c:364
SDL_WarpMouseInWindow
void SDL_WarpMouseInWindow(SDL_Window *window, int x, int y)
Moves the mouse to the given position within the window.
Definition: SDL_mouse.c:756
SDL_ShowCursor
int SDL_ShowCursor(int toggle)
Toggle whether or not the cursor is shown.
Definition: SDL_mouse.c:1108
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974
SDL_Window
The type used to identify a window.
Definition: SDL_sysvideo.h:73
SDL_GetKeyboardFocus
#define SDL_GetKeyboardFocus
Definition: SDL_dynapi_overrides.h:216
SDL_MouseTouchEventsChanged
static void SDL_MouseTouchEventsChanged(void *userdata, const char *name, const char *oldValue, const char *hint)
Definition: SDL_mouse.c:111
SDL_strcasecmp
#define SDL_strcasecmp
Definition: SDL_dynapi_overrides.h:419
SDL_TOUCH_MOUSEID
#define SDL_TOUCH_MOUSEID
Definition: SDL_touch.h:61
SDL_GetWindowSize
#define SDL_GetWindowSize
Definition: SDL_dynapi_overrides.h:527
SDL_Mouse::mouse_touch_events
SDL_bool mouse_touch_events
Definition: SDL_mouse_c.h:96
SDL_Window::w
int w
Definition: SDL_sysvideo.h:80
SDL_Mouse::was_touch_mouse_events
SDL_bool was_touch_mouse_events
Definition: SDL_mouse_c.h:97
SDL_PRESSED
#define SDL_PRESSED
Definition: SDL_events.h:50
SDL_Mouse::ydelta
int ydelta
Definition: SDL_mouse_c.h:81
SDL_CaptureMouse
int SDL_CaptureMouse(SDL_bool enabled)
Capture the mouse, to track input outside an SDL window.
Definition: SDL_mouse.c:861
SDL_GetHintBoolean
#define SDL_GetHintBoolean
Definition: SDL_dynapi_overrides.h:608
event
struct _cl_event * event
Definition: SDL_opengl_glext.h:2649
SDL_Mouse::MoveCursor
void(* MoveCursor)(SDL_Cursor *cursor)
Definition: SDL_mouse_c.h:55
SDL_FALSE
@ SDL_FALSE
Definition: SDL_stdinc.h:163
SDL_AddTouch
int SDL_AddTouch(SDL_TouchID touchID, SDL_TouchDeviceType type, const char *name)
Definition: SDL_touch.c:155
SDL_Mouse::relative_mode
SDL_bool relative_mode
Definition: SDL_mouse_c.h:87
SDL_MOUSEMOTION
@ SDL_MOUSEMOTION
Definition: SDL_events.h:105
SDL_BUTTON_LEFT
#define SDL_BUTTON_LEFT
Definition: SDL_mouse.h:282
SDL_atof
#define SDL_atof
Definition: SDL_dynapi_overrides.h:411
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
SDL_Mouse::WarpMouse
void(* WarpMouse)(SDL_Window *window, int x, int y)
Definition: SDL_mouse_c.h:61
SDL_UpdateMouseFocus
static SDL_bool SDL_UpdateMouseFocus(SDL_Window *window, int x, int y, Uint32 buttonstate, SDL_bool send_mouse_motion)
Definition: SDL_mouse.c:249
SDL_GetEventState
#define SDL_GetEventState(type)
Definition: SDL_events.h:772
window
EGLSurface EGLNativeWindowType * window
Definition: eglext.h:1025
SDL_free
#define SDL_free
Definition: SDL_dynapi_overrides.h:377
f
GLfloat f
Definition: SDL_opengl_glext.h:1870
SDL_PushEvent
#define SDL_PushEvent
Definition: SDL_dynapi_overrides.h:125
SDL_max
#define SDL_max(x, y)
Definition: SDL_stdinc.h:407
SDL_mouse
static SDL_Mouse SDL_mouse
Definition: SDL_mouse.c:38
GetMouseClickState
static SDL_MouseClickState * GetMouseClickState(SDL_Mouse *mouse, Uint8 button)
Definition: SDL_mouse.c:475
SDL_MouseClickState::click_count
Uint8 click_count
Definition: SDL_mouse_c.h:40
SDL_Mouse::relative_speed_scale
float relative_speed_scale
Definition: SDL_mouse_c.h:90
SDL_MouseClickState::last_timestamp
Uint32 last_timestamp
Definition: SDL_mouse_c.h:39
SDL_SendMouseMotion
int SDL_SendMouseMotion(SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
Definition: SDL_mouse.c:301
SDL_Mouse::def_cursor
SDL_Cursor * def_cursor
Definition: SDL_mouse_c.h:104
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
SDL_MOUSEWHEEL
@ SDL_MOUSEWHEEL
Definition: SDL_events.h:108
GetScaledMouseDelta
static int GetScaledMouseDelta(float scale, int value, float *accum)
Definition: SDL_mouse.c:314
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_GetTicks
Uint32 SDL_GetTicks(void)
Get the number of milliseconds since the SDL library initialization.
SDL_min
#define SDL_min(x, y)
Definition: SDL_stdinc.h:406
SDL_UpdateWindowGrab
void SDL_UpdateWindowGrab(SDL_Window *window)
Definition: SDL_video.c:2520
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::CreateSystemCursor
SDL_Cursor *(* CreateSystemCursor)(SDL_SystemCursor id)
Definition: SDL_mouse_c.h:49
SDL_PIXELFORMAT_ARGB8888
@ SDL_PIXELFORMAT_ARGB8888
Definition: SDL_pixels.h:248
SDL_Mouse::relative_mode_warp
SDL_bool relative_mode_warp
Definition: SDL_mouse_c.h:88
hot_x
int uint32_t uint32_t uint32_t uint32_t uint32_t int drmModeModeInfoPtr mode int uint32_t uint32_t uint32_t uint32_t int32_t hot_x
Definition: SDL_kmsdrmsym.h:57
SDL_MouseDoubleClickRadiusChanged
static void SDL_MouseDoubleClickRadiusChanged(void *userdata, const char *name, const char *oldValue, const char *hint)
Definition: SDL_mouse.c:63
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_Window::h
int h
Definition: SDL_sysvideo.h:80
SDL_Mouse::accumulated_wheel_y
float accumulated_wheel_y
Definition: SDL_mouse_c.h:84
cursor
SDL_Cursor * cursor
Definition: testwm2.c:40
SDL_Mouse::ShowCursor
int(* ShowCursor)(SDL_Cursor *cursor)
Definition: SDL_mouse_c.h:52
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
SDL_Mouse::num_clickstates
int num_clickstates
Definition: SDL_mouse_c.h:100
SDL_MOUSE_TOUCHID
#define SDL_MOUSE_TOUCHID
Definition: SDL_touch.h:64
SDL_CreateRGBSurface
#define SDL_CreateRGBSurface
Definition: SDL_dynapi_overrides.h:444
SDL_Mouse::xdelta
int xdelta
Definition: SDL_mouse_c.h:80
SDL_atoi
#define SDL_atoi
Definition: SDL_dynapi_overrides.h:410
SDL_Mouse::last_y
int last_y
Definition: SDL_mouse_c.h:82
SDL_SetRelativeMouseMode
int SDL_SetRelativeMouseMode(SDL_bool enabled)
Set relative mouse mode.
Definition: SDL_mouse.c:799
SDL_HINT_MOUSE_DOUBLE_CLICK_TIME
#define SDL_HINT_MOUSE_DOUBLE_CLICK_TIME
A variable setting the double click time, in milliseconds.
Definition: SDL_hints.h:268
SDL_MouseRelativeSpeedScaleChanged
static void SDL_MouseRelativeSpeedScaleChanged(void *userdata, const char *name, const char *oldValue, const char *hint)
Definition: SDL_mouse.c:87
SDL_TRUE
@ SDL_TRUE
Definition: SDL_stdinc.h:164
SDL_AddHintCallback
#define SDL_AddHintCallback
Definition: SDL_dynapi_overrides.h:192
SDL_Mouse::last_x
int last_x
Definition: SDL_mouse_c.h:82
SDL_Mouse::x
int x
Definition: SDL_mouse_c.h:78
value
GLsizei const GLfloat * value
Definition: SDL_opengl_glext.h:698
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_Mouse::clickstate
SDL_MouseClickState * clickstate
Definition: SDL_mouse_c.h:101
SDL_Window::id
Uint32 id
Definition: SDL_sysvideo.h:76
SDL_HINT_MOUSE_TOUCH_EVENTS
#define SDL_HINT_MOUSE_TOUCH_EVENTS
A variable controlling whether mouse events should generate synthetic touch events.
Definition: SDL_hints.h:326
SDL_Mouse::has_position
SDL_bool has_position
Definition: SDL_mouse_c.h:86
SDL_Mouse::FreeCursor
void(* FreeCursor)(SDL_Cursor *cursor)
Definition: SDL_mouse_c.h:58
SDL_HINT_MOUSE_NORMAL_SPEED_SCALE
#define SDL_HINT_MOUSE_NORMAL_SPEED_SCALE
A variable setting the speed scale for mouse motion, in floating point, when the mouse is not in rela...
Definition: SDL_hints.h:278
SDL_Mouse::CreateCursor
SDL_Cursor *(* CreateCursor)(SDL_Surface *surface, int hot_x, int hot_y)
Definition: SDL_mouse_c.h:46
SDL_SendWindowEvent
int SDL_SendWindowEvent(SDL_Window *window, Uint8 windowevent, int data1, int data2)
Definition: SDL_windowevents.c:74
SDL_Mouse::GetGlobalMouseState
Uint32(* GetGlobalMouseState)(int *x, int *y)
Definition: SDL_mouse_c.h:73
SDL_Mouse::mouseID
SDL_MouseID mouseID
Definition: SDL_mouse_c.h:76
SDL_MOUSEBUTTONDOWN
@ SDL_MOUSEBUTTONDOWN
Definition: SDL_events.h:106
enabled
GLenum GLenum GLsizei const GLuint GLboolean enabled
Definition: SDL_opengl_glext.h:2479
SDL_TICKS_PASSED
#define SDL_TICKS_PASSED(A, B)
Compare SDL ticks values, and return true if A has passed B.
Definition: SDL_timer.h:56
SDL_FreeCursor
void SDL_FreeCursor(SDL_Cursor *cursor)
Frees a cursor created with SDL_CreateCursor() or similar functions.
Definition: SDL_mouse.c:1074
SDL_Event
General event structure.
Definition: SDL_events.h:557
SDL_DelHintCallback
#define SDL_DelHintCallback
Definition: SDL_dynapi_overrides.h:193
SDL_Unsupported
#define SDL_Unsupported()
Definition: SDL_error.h:53
track_mouse_down
static SDL_bool track_mouse_down
Definition: SDL_mouse.c:41
SDL_BUTTON
#define SDL_BUTTON(X)
Definition: SDL_mouse.h:281
SDL_HINT_MOUSE_RELATIVE_MODE_WARP
#define SDL_HINT_MOUSE_RELATIVE_MODE_WARP
A variable controlling whether relative mouse mode is implemented using mouse warping.
Definition: SDL_hints.h:294
SDL_MouseClickState::last_y
int last_y
Definition: SDL_mouse_c.h:38
SDL_MouseClickState::last_x
int last_x
Definition: SDL_mouse_c.h:38
SDL_Window::flags
Uint32 flags
Definition: SDL_sysvideo.h:83
type
GLuint GLuint GLsizei GLenum type
Definition: SDL_opengl.h:1571
state
struct xkb_state * state
Definition: SDL_waylandsym.h:113
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_Mouse::double_click_time
Uint32 double_click_time
Definition: SDL_mouse_c.h:93
button
SDL_Texture * button
Definition: testgamecontroller.c:67
SDL_Mouse::cur_cursor
SDL_Cursor * cur_cursor
Definition: SDL_mouse_c.h:105
SDL_HINT_MOUSE_RELATIVE_SPEED_SCALE
#define SDL_HINT_MOUSE_RELATIVE_SPEED_SCALE
A variable setting the scale for mouse motion, in floating point, when the mouse is in relative mode.
Definition: SDL_hints.h:283
SDL_WINDOWEVENT_LEAVE
@ SDL_WINDOWEVENT_LEAVE
Definition: SDL_video.h:164
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:161
SDL_Mouse::cursor_shown
SDL_bool cursor_shown
Definition: SDL_mouse_c.h:106
w
GLubyte GLubyte GLubyte GLubyte w
Definition: SDL_opengl_glext.h:731
SDL_PrivateSendMouseButton
static int SDL_PrivateSendMouseButton(SDL_Window *window, SDL_MouseID mouseID, Uint8 state, Uint8 button, int clicks)
Definition: SDL_mouse.c:494
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:179